Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3679)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3681)
@@ -5983,206 +7779,80 @@
                ENDIF
             
-               ijk = 1           
-               DO  i = ifl(l), ifu(l)
-                  DO  ja = jfl(m), jfu(m)
-                     DO  k = kfl(n), kfu(n)
-                        rcorr_ijk = rcorr * celltmpd(ijk) / cellsumd 
-                        f(k,ja,i) = f(k,ja,i) + rcorr_ijk
-                        ijk = ijk + 1
-                     ENDDO
-                  ENDDO
-               ENDDO
-               
-            ENDDO  ! n
-         ENDDO  ! l 
-
-      ENDIF  ! var not u or w
-!
-!--   Store the boundary values also into the other redundant ghost node layers.
-!--   Note that in case of only one ghost node layer, e.g. for the PW 
-!--   scheme, the following loops will not be entered.
-      IF ( edge == 's' )  THEN
-         DO  jbgp = -nbgp, jb
-            f(0:nzt+1,jbgp,nxlg:nxrg) = f(0:nzt+1,j,nxlg:nxrg)
-         ENDDO
-      ELSEIF ( edge == 'n' )  THEN
-         DO  jbgp = jb, ny+nbgp
-            f(0:nzt+1,jbgp,nxlg:nxrg) = f(0:nzt+1,j,nxlg:nxrg)
-         ENDDO
-      ENDIF
-
-   END SUBROUTINE pmci_interp_tril_sn
-
- 
-
-   SUBROUTINE pmci_interp_tril_t( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y,       &
-                                  r1z, r2z, kct, ifl, ifu, jfl, jfu, kfl, kfu, &
-                                  ijkfc, var )
-
-!
-!--   Interpolation of ghost-node values used as the child-domain boundary
-!--   conditions. This subroutine handles the top boundary. 
-!--   This subroutine is based on trilinear interpolation.
-
-      IMPLICIT NONE
-
-      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                      &
-                                      INTENT(INOUT) ::  f     !<
-      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr),                          &
-                                      INTENT(IN)    ::  fc    !<
-      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)    ::  r1x   !<
-      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)    ::  r2x   !<
-      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)    ::  r1y   !<
-      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)    ::  r2y   !<
-      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r1z   !<
-      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r2z   !<
-      
-      INTEGER(iwp), DIMENSION(nxlg:nxrg), INTENT(IN) ::  ic    !<
-      INTEGER(iwp), DIMENSION(nysg:nyng), INTENT(IN) ::  jc    !<
-      INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN) ::  kc    !<
-      
-      INTEGER(iwp) :: kct
-      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
-      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
-      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
-      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
-!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
-!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
-      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
-      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
-!AH      INTEGER(iwp), DIMENSION(0:kct,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
-      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
-
-      CHARACTER(LEN=1), INTENT(IN) :: var   !<
-
-      INTEGER(iwp) ::  i   !<
-      INTEGER(iwp) ::  ib  !<
-      INTEGER(iwp) ::  ie  !<
-      INTEGER(iwp) ::  ijk !<
-      INTEGER(iwp) ::  j   !<
-      INTEGER(iwp) ::  jb  !<
-      INTEGER(iwp) ::  je  !<      
-      INTEGER(iwp) ::  k   !<
-      INTEGER(iwp) ::  ka  !<
-      INTEGER(iwp) ::  l   !<
-      INTEGER(iwp) ::  m   !<
-      INTEGER(iwp) ::  n   !<
-      INTEGER(iwp) ::  var_flag  !<
-      
-      REAL(wp) ::  cellsum     !<
-      REAL(wp) ::  cellsumd    !<
-      REAL(wp) ::  fk          !<
-      REAL(wp) ::  fkj         !<
-      REAL(wp) ::  fkjp        !<
-      REAL(wp) ::  fkpj        !<
-      REAL(wp) ::  fkpjp       !<
-      REAL(wp) ::  fkp         !<
-      REAL(wp) ::  rcorr       !<
-      REAL(wp) ::  rcorr_ijk   !<
-
-
-      IF ( var == 'w' )  THEN
-         k  = nzt
-      ELSE
-         k  = nzt + 1
-      ENDIF
-!
-!--   These exceedings by one are needed only to avoid stripes
-!--   and spots in visualization. They have no effect on the 
-!--   actual solution.     
-      ib = nxl-1
-      ie = nxr+1
-      jb = nys-1
-      je = nyn+1
-
-      IF ( var == 'u' )  THEN 
-         var_flag = 1 
-      ELSEIF ( var == 'v' )  THEN
-         var_flag = 2 
-      ELSEIF ( var == 'w' )  THEN
-         var_flag = 3
-      ELSE
-         var_flag = 0
-      ENDIF
-         
-      DO  i = ib, ie
-         DO  j = jb, je
-            l = ic(i)
-            m = jc(j)
-            n = kc(k)            
-            fkj      = r1x(i) * fc(n,m,l)     + r2x(i) * fc(n,m,l+1)
-            fkjp     = r1x(i) * fc(n,m+1,l)   + r2x(i) * fc(n,m+1,l+1)
-            fkpj     = r1x(i) * fc(n+1,m,l)   + r2x(i) * fc(n+1,m,l+1)
-            fkpjp    = r1x(i) * fc(n+1,m+1,l) + r2x(i) * fc(n+1,m+1,l+1)
-            fk       = r1y(j) * fkj  + r2y(j) * fkjp
-            fkp      = r1y(j) * fkpj + r2y(j) * fkpjp
-            f(k,j,i) = r1z(k) * fk   + r2z(k) * fkp
-         ENDDO
-      ENDDO
-!
-!--   Apply the reversibility correction to the boundary-normal velocity-
-!--   component w and scalars. It must not be applied to the boundary-
-!--   tangential velocity components u and v because their 2-D anterpolation 
-!--   cells do not cover all the child-grid nodes on the boundary.
-      IF ( .NOT. ( ( var == 'u' ) .OR. ( var == 'v' ) ) )  THEN  
-         IF ( var == 'w' )  THEN
-            n = kc(k)
-         ELSE
-            n = kc(k) + 1
-         ENDIF
-
-         DO  l = icl, icr
-            DO  m = jcs, jcn
-               ijk = 1
-               cellsum   = 0.0_wp
-               cellsumd  = 0.0_wp
-               DO  i = ifl(l), ifu(l)
-                  DO  j = jfl(m), jfu(m)
-                     DO  ka = kfl(n), kfu(n)
-                        cellsum = cellsum + MERGE( f(ka,j,i), 0.0_wp,           &
-                             BTEST( wall_flags_0(ka,j,i), var_flag ) )
-                        celltmpd(ijk) = ABS( fc(n,m,l) - f(ka,j,i) )
-                        cellsumd      = cellsumd  + MERGE( celltmpd(ijk),       &
-                             0.0_wp, BTEST( wall_flags_0(ka,j,i), var_flag ) )                     
-                        ijk = ijk + 1
-                     ENDDO
-                  ENDDO
-               ENDDO
-
-               IF ( ijkfc(n,m,l) /= 0 )  THEN
-                  cellsum   = cellsum / REAL( ijkfc(n,m,l), KIND=wp )
-                  rcorr     = fc(n,m,l) - cellsum
-                  cellsumd  = cellsumd / REAL( ijkfc(n,m,l), KIND=wp )
-               ELSE
-                  cellsum   = 0.0_wp
-                  rcorr     = 0.0_wp
-                  cellsumd  = 1.0_wp
-                  celltmpd  = 1.0_wp
-               ENDIF
-
-               IF ( ABS(rcorr) < 0.000001_wp )  THEN                  
-                  cellsumd  = 1.0_wp
-                  celltmpd  = 1.0_wp
-               ENDIF
-
                ijk = 1
                DO  i = ifl(l), ifu(l)
-                  DO  j = jfl(m), jfu(m)
-                     DO  ka = kfl(n), kfu(n)
-                        rcorr_ijk = rcorr * celltmpd(ijk) / cellsumd 
-                        f(ka,j,i) = f(ka,j,i) + rcorr_ijk
-                        ijk = ijk + 1
+                  IF  ( ( i >= nxl ) .AND. ( i <= nxr+1 ) )  THEN
+                     DO  j = jfl(m), jfu(m)
+                        IF  ( ( j >= nys ) .AND. ( j <= nyn+1 ) )  THEN
+                           DO  ka = kfl(n), kfu(n)
+                              rcorr_ijk = rcorr * celltmpd(ijk) / cellsumd 
+!AH                            f(ka,j,i) = f(ka,j,i) + rcorr_ijk
+                              workarr_t(ka,j,i) = workarr_t(ka,j,i) + rcorr_ijk
+
+!                                 if  ( i == 128 .and. var == 'u' )  then
+!                                    write(9,"('t2: ', 8(i4,2x),3(e12.5,2x))") nw, m, l, ka, j, i, ifl(l), ifu(l), &
+!                                         rcorr, rcorr_ijk, workarr_t(ka,j,i)
+!                                    flush(9)
+!                                 endif
+
+                              ijk = ijk + 1
+                           ENDDO
+                        ENDIF
                      ENDDO
+                  ENDIF
+               ENDDO
+!
+!--            Velocity components tangential to the boundary need special 
+!--            "finishing" because their anterpolation cells are flat in their 
+!--            direction and hence do not cover all the child-grid boundary nodes. 
+!--            These components are next linearly interpolated to those child-grid 
+!--            boundary nodes which are not covered by the anterpolation cells. 
+               IF  ( ( var == 'v' ) .AND. ( m > jcs ) )  THEN
+                  DO  j = jfu(m-1)+1, jfl(m)-1
+                     IF  ( ( j >= nys ) .AND. ( j <= nyn+1 ) )  THEN
+                        DO  i = ifl(l), ifu(l)
+                           IF  ( ( i >= nxl ) .AND. ( i <= nxr+1 ) )  THEN
+                              DO  ka = kfl(n), kfu(n)        ! This loop should be removed and fixed k-value be used instead
+!AH                              f(ka,j,i) = r1y(j) * f(ka,jfu(m-1),i)             &
+!AH                                   + r2y(j) * f(ka,jfl(m),i)
+                                 workarr_t(ka,j,i) = r1y(j) * workarr_t(ka,jfu(m-1),i) &
+                                      + r2y(j) * workarr_t(ka,jfl(m),i)
+                              ENDDO
+                           ENDIF
+                        ENDDO
+                     ENDIF
                   ENDDO
-               ENDDO
+               ENDIF
+               
+               IF  ( ( var == 'u' ) .AND. ( l > icl ) )  THEN
+                  DO  i = ifu(l-1)+1, ifl(l)-1
+                     IF  ( ( i >= nxl ) .AND. ( i <= nxr+1 ) )  THEN
+                        DO  j = jfl(m), jfu(m)
+                           IF  ( ( j >= nys ) .AND. ( j <= nyn+1 ) )  THEN
+                              DO  ka = kfl(n), kfu(n)        ! This loop should be removed and fixed k-value be used instead
+!AH                              f(ka,j,i) = r1x(i) * f(ka,j,ifu(l-1)) +           &
+!AH                                   r2x(i) * f(ka,j,ifl(l))
+                                 workarr_t(ka,j,i) = r1x(i) * workarr_t(ka,j,ifu(l-1)) &
+                                      + r2x(i) * workarr_t(ka,j,ifl(l))
+
+!                                 if  ( i == 127 )  then
+!                                    write(9,"('t4: ', 8(i4,2x),3(e12.5,2x))") nw, m, l, ka, j, ifu(l-1), i, ifl(l), &
+!                                         workarr_t(ka,j,ifu(l-1)), workarr_t(ka,j,i), workarr_t(ka,j,ifl(l))
+!                                    flush(9)
+!                                 endif
+
+                              ENDDO
+                           ENDIF
+                        ENDDO
+                     ENDIF
+                  ENDDO
+               ENDIF
                
             ENDDO  ! m
          ENDDO  ! l
-
-      ENDIF  ! var not u or v
-!
-!--   Just fill up the redundant second ghost-node layer for w.
-      IF ( var == 'w' )  THEN
-         f(nzt+1,:,:) = f(nzt,:,:)
+!
+!--   Finally substitute the boundary values.
+      f(k,nys:nyn,nxl:nxr) = workarr_t(k,nys:nyn,nxl:nxr)
+      IF  ( var == 'w' )  THEN
+         f(k+1,nys:nyn,nxl:nxr) = f(k,nys:nyn,nxl:nxr)
       ENDIF
 
@@ -6204,16 +7874,20 @@
 
 !AH       INTEGER(iwp), DIMENSION(0:kct,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
-       INTEGER(iwp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+!AH
+!       INTEGER(iwp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+       INTEGER(iwp), DIMENSION(0:cg%nz+1,jcsa:jcna,icla:icra), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+!AH
 
        INTEGER(iwp) ::  i         !< Running index x-direction - fine-grid
-       INTEGER(iwp) ::  icla      !< Left boundary index for anterpolation along x
-       INTEGER(iwp) ::  icra      !< Right boundary index for anterpolation along x
+       INTEGER(iwp) ::  iclant    !< Left boundary index for anterpolation along x
+       INTEGER(iwp) ::  icrant    !< Right boundary index for anterpolation along x
        INTEGER(iwp) ::  ii        !< Running index x-direction - coarse grid
        INTEGER(iwp) ::  j         !< Running index y-direction - fine-grid
-       INTEGER(iwp) ::  jcna      !< North boundary index for anterpolation along y
-       INTEGER(iwp) ::  jcsa      !< South boundary index for anterpolation along y
+       INTEGER(iwp) ::  jcnant    !< North boundary index for anterpolation along y
+       INTEGER(iwp) ::  jcsant    !< South boundary index for anterpolation along y
        INTEGER(iwp) ::  jj        !< Running index y-direction - coarse grid
        INTEGER(iwp) ::  k         !< Running index z-direction - fine-grid     
        INTEGER(iwp) ::  kcb = 0   !< Bottom boundary index for anterpolation along z
+       INTEGER(iwp) ::  kctant    !< Top boundary index for anterpolation along z
        INTEGER(iwp) ::  kk        !< Running index z-direction - coarse grid
        INTEGER(iwp) ::  var_flag  !< bit number used to flag topography on respective grid
@@ -6221,8 +7895,15 @@
        INTEGER(iwp), INTENT(IN) ::  kct   !< Top boundary index for anterpolation along z
 
-       INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
-       INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
-       INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
-       INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+!AH
+!       INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
+!       INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
+!       INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
+!       INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+       INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
+       INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
+       INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
+       INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+!AH
+
 !AH       INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
 !AH       INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
@@ -6237,45 +7918,33 @@
   
 !
-!--    Define the index bounds icla, icra, jcsa and jcna.
+!--    Define the index bounds iclant, icrant, jcsant and jcnant.
 !--    Note that kcb is simply zero and kct enters here as a parameter and it is
 !--    determined in pmci_init_anterp_tophat.
 !--    Please note, grid points used also for interpolation (from parent to
 !--    child) are excluded in anterpolation, e.g. anterpolation is only from 
-!--    nzb:kct-1, as kct is used for interpolation. Following this approach
-!--    avoids numerical problems which may accumulate, particularly for shallow
-!--    child domain, leading to increased velocity variances. A more 
-!--    comprehensive explanation for this is still pending.
-       icla = coarse_bound_anterp(1)
-       icra = coarse_bound_anterp(2) 
-       jcsa = coarse_bound_anterp(3)
-       jcna = coarse_bound_anterp(4)
+!--    nzb:kct-1, as kct is used for interpolation.
+       iclant = icl
+       icrant = icr
+       jcsant = jcs
+       jcnant = jcn
+       kctant = kct - 1
+
        kcb  = 0
        IF ( nesting_mode /= 'vertical' )  THEN
           IF ( bc_dirichlet_l )  THEN
-             IF ( var == 'u' )  THEN
-                icla = coarse_bound_anterp(1) + 2
-             ELSE
-                icla = coarse_bound_anterp(1) + 1
-             ENDIF
+             iclant = icl + 3
           ENDIF
           IF ( bc_dirichlet_r )  THEN
-             icra = coarse_bound_anterp(2) - 1
+!             icrant = icr - 5
+             icrant = icr - 3
           ENDIF
 
           IF ( bc_dirichlet_s )  THEN
-             IF ( var == 'v' )  THEN
-                jcsa = coarse_bound_anterp(3) + 2
-             ELSE
-                jcsa = coarse_bound_anterp(3) + 1
-             ENDIF
+             jcsant = jcs + 3
           ENDIF
           IF ( bc_dirichlet_n )  THEN
-             jcna = coarse_bound_anterp(4) - 1
+             jcnant = jcn - 3
           ENDIF
        ENDIF
-
-!       write(9,"('pmci_anterp_tophat: ',4(e12.5,2x))")   &
-!            cg%coord_x(icla), cg%coord_y(jcsa),  cg%coord_x(icra), cg%coord_y(jcna)  
-!       flush(9)
 !
 !--    Set masking bit for topography flags 
@@ -6292,10 +7961,10 @@
 !--    Note that ii, jj, and kk are coarse-grid indices and i,j, and k 
 !--    are fine-grid indices.
-       DO  ii = icla, icra
-          DO  jj = jcsa, jcna
+       DO  ii = iclant, icrant
+          DO  jj = jcsant, jcnant
 !
 !--          For simplicity anterpolate within buildings and under elevated
 !--          terrain too
-             DO  kk = kcb, kct - 1                
+             DO  kk = kcb, kctant !kct - 1
                 cellsum = 0.0_wp
                 DO  i = ifl(ii), ifu(ii)
@@ -6310,5 +7979,5 @@
 !--             Spatial under-relaxation.
 !--             The relaxation buffer zones are no longer needed with
-!--             the new reversible interpolation algorithm. 23.19.2018.
+!--             the new reversible interpolation algorithm. 23.10.2018.
 !                fra  = frax(ii) * fray(jj) * fraz(kk)                
 !
@@ -6318,13 +7987,13 @@
 !--             particular for the temperature. Therefore, in case cellsum is 
 !--             zero, keep the parent solution at this point. 
+
                 IF ( ijkfc(kk,jj,ii) /= 0 )  THEN
-!                   fc(kk,jj,ii) = ( 1.0_wp - fra ) * fc(kk,jj,ii) +         &
-!                        fra * cellsum  /                                    &
-!                        REAL( ijkfc(kk,jj,ii), KIND=wp )
+!AH                   fc(kk,jj,ii) = ( 1.0_wp - fra ) * fc(kk,jj,ii) +         &
+!AH                        fra * cellsum  /                                    &
+!AH                        REAL( ijkfc(kk,jj,ii), KIND=wp )
                    fc(kk,jj,ii) = cellsum / REAL( ijkfc(kk,jj,ii), KIND=wp )
                 ENDIF
 
              ENDDO
-
           ENDDO
        ENDDO
